''/*******************************************************************************  
'' *  (c) by Knobloch GmbH
'' *         Weedgasse 14
'' *         D-55234 Erbes-Bdesheim                                    
' '*
'' *  Header:         FtLibDllFunc.h      Headerfile for fischertechnik Library
'' *                                      Load DLL-Library 
'' *
'' *  Version:        0.60
'' *  Date:           10. May 2006
'' *
'' *  Revision:
'' *  0.60:   10. May 2006
'' *          New Name: GetAnzFtUsbDevice()    --> GetNumFtUsbDevice()
'' *                    ClearFtMessagePuffer() --> ClearFtMessageBuffer()
'' * Umgesetzt auf FreeBasic von Werner Hobelbrecht
'' ********************************************************************************/
''Handle to DLL

    DIM Shared hFtLibDLL       As any Ptr
    DIM Shared ftDCB           as FT_TRANSFER_AREA ptr
    DIM Shared hUsb            as FT_HANDLE
    DIM Shared dwStatus        as DWORD
    DIM Shared ft_call_backs   as NOTIFICATION_EVENTS

    DIM Shared end_thread as Any Ptr
    Dim Shared outsync As Any Ptr
    Dim Shared ft_transfer_ready As Any Ptr
    
    
    
    
    DIM Shared GetLibVersion AS FUNCTION stdcall () AS DWORD
    DIM Shared InitFtLib AS FUNCTION stdcall  () AS DWORD
    DIM Shared CloseFtLib AS FUNCTION stdcall () AS DWORD
    DIM Shared IsFtLibInit AS FUNCTION stdcall () AS DWORD 
    DIM Shared InitFtUsbDeviceList AS FUNCTION stdcall () AS DWORD 
    DIM Shared GetNumFtUsbDevice AS FUNCTION stdcall () AS UINTEGER 
    DIM Shared GetFtUsbDeviceHandle AS FUNCTION stdcall ( BYVAL ucDevNr AS UBYTE) AS FT_HANDLE
    DIM Shared GetFtUsbDeviceHandleSerialNr AS FUNCTION stdcall ( BYVAL dwSN AS DWORD, BYVAL dwType AS DWORD) AS FT_HANDLE
    DIM Shared OpenFtUsbDevice AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD 
    DIM Shared OpenFtCommDevice AS FUNCTION stdcall (BYVAL dwPort as DWORD,BYVAL dwTyp as DWORD, BYVAL dwZyklus as DWORD, BYVAL pdwError as DWORD PTR ) AS FT_HANDLE
    DIM Shared SetFtDeviceCommMode AS FUNCTION stdcall (BYVAL hFT as FT_HANDLE,BYVAL dwMode as DWORD, BYVAL dwParameter as DWORD,BYVAL puiValue as USHORT PTR) as DWORD 
    DIM Shared CloseAllFtDevices AS FUNCTION stdcall () AS DWORD
    DIM Shared CloseFtDevice AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared GetFtDeviceTyp           AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared GetFtSerialNrStrg        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS LPCSTR 
    DIM Shared GetFtSerialNr            AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared GetFtFirmwareStrg        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS LPCSTR
    DIM Shared GetFtFirmware            AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared GetFtManufacturerStrg    AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS LPCSTR
    DIM Shared GetFtShortNameStrg       AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS LPCSTR
    DIM Shared GetFtLongNameStrg        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS LPCSTR
    DIM Shared GetFtLibErrorString      AS FUNCTION stdcall (BYVAL dwErrorCode as DWORD,BYVAL dwTyp as DWORD) AS LPCSTR
    DIM Shared GetFtDeviceSetting       AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE, BYVAL pSet as FT_SETTING PTR) as DWORD
    DIM Shared SetFtDeviceSetting       AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE, BYVAL pSet as FT_SETTING PTR) as DWORD
    DIM Shared SetFtDistanceSensorMode  AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE ,BYVAL dwMode as DWORD,BYVAL dwTol1 as DWORD,BYVAL dwTol2 as DWORD,BYVAL dwSchwell1 as DWORD,BYVAL dwSchwell2 as DWORD,BYVAL dwRepeat1 as DWORD,BYVAL dwRepeat2 as DWORD) as DWORD
    DIM Shared StartFtTransferArea      AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE, BYVAL sNEvent as NOTIFICATION_EVENTS PTR) as DWORD
    DIM Shared StartFtTransferAreaWithCommunication AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE, BYVAL sNEvent as NOTIFICATION_EVENTS PTR) as DWORD
    DIM Shared StopFtTransferArea       AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared GetFtTransferAreaAddress AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS FT_TRANSFER_AREA PTR
    DIM Shared IsFtTransferActiv        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared ResetFtTransfer          AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared GetFtMemoryLayout        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE, BYVAL pbArray as BYTE PTR,BYVAL dwSize as DWORD) as DWORD
    DIM Shared DownloadFtProgram        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL dwMemBlock as DWORD,BYVAL pbArray as BYTE PTR,BYVAL dwSize as DWORD,BYVAL dwParameter as DWORD,BYVAL pbName as BYTE PTR,BYVAL dwNameLen as DWORD) as DWORD
    DIM Shared StartFtProgram           AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL dwMemBlock as DWORD) as DWORD
    DIM Shared StopFtProgram            AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD
    DIM Shared DeleteFtProgram          AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL dwMemBlock as DWORD) as DWORD
    DIM Shared SetFtProgramActiv        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL dwMemBlock as DWORD) as DWORD
    DIM Shared GetFtProgramName         AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL dwMemBlock as DWORD,BYVAL dwSize as DWORD,BYVAL pName as LPVOID) as DWORD
    DIM Shared WriteFtMemoryData        AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL dwData as DWORD,BYVAL dwAdress as DWORD) as DWORD
    DIM Shared GetFtMemoryData          AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL pbArray as BYTE PTR,BYVAL dwSize as DWORD,BYVAL dwAdress as DWORD) as DWORD
    DIM Shared SendFtMessage            AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE,BYVAL bHwId as BYTE,BYVAL bSubId as BYTE,BYVAL dwMessage as DWORD,BYVAL dwWaitTime as DWORD) as DWORD
    DIM Shared ClearFtMessageBuffer     AS FUNCTION stdcall (BYVAL hFt as FT_HANDLE) AS DWORD


  ''  typedef DWORD       (__stdcall *DLL_GetLibVersion) (void);
  ''  typedef DWORD       (__stdcall *DLL_InitFtLib) (void);
  ''  typedef DWORD       (__stdcall *DLL_CloseFtLib) (void);
  ''  typedef DWORD       (__stdcall *DLL_IsFtLibInit) (void);
  ''  typedef DWORD       (__stdcall *DLL_InitFtUsbDeviceList) (void);
  ''  typedef UINT        (__stdcall *DLL_GetNumFtUsbDevice) (void);
  ''  typedef FT_HANDLE   (__stdcall *DLL_GetFtUsbDeviceHandle) (UCHAR ucDevNr);
  ''  typedef FT_HANDLE   (__stdcall *DLL_GetFtUsbDeviceHandleSerialNr) (DWORD dwSN, DWORD dwTyp);
  ''  typedef DWORD       (__stdcall *DLL_OpenFtUsbDevice) (FT_HANDLE hFt);
  ''  typedef FT_HANDLE   (__stdcall *DLL_OpenFtCommDevice) (DWORD dwPort, DWORD dwTyp, DWORD dwZyklus, DWORD *pdwError);
  ''  typedef DWORD       (__stdcall *DLL_SetFtDeviceCommMode) (FT_HANDLE hFt, DWORD dwMode, DWORD dwParameter, USHORT *puiValue);
  ''  typedef DWORD       (__stdcall *DLL_CloseAllFtDevices) (void);
  ''  typedef DWORD       (__stdcall *DLL_CloseFtDevice) (FT_HANDLE hFt);
  ''  typedef DWORD       (__stdcall *DLL_GetFtDeviceTyp) (FT_HANDLE hFt);
  ''  typedef LPCSTR      (__stdcall *DLL_GetFtSerialNrStrg) (FT_HANDLE hFt);
  ''  typedef DWORD       (__stdcall *DLL_GetFtSerialNr) (FT_HANDLE hFt);
 
  ''  typedef LPCSTR      (__stdcall *DLL_GetFtFirmwareStrg) (FT_HANDLE hFt);
  ''  typedef DWORD       (__stdcall *DLL_GetFtFirmware) (FT_HANDLE hFt);
  
  ''  typedef LPCSTR      (__stdcall *DLL_GetFtManufacturerStrg) (FT_HANDLE hFt);
  '   typedef LPCSTR      (__stdcall *DLL_GetFtShortNameStrg) (FT_HANDLE hFt);
  ''  typedef LPCSTR      (__stdcall *DLL_GetFtLongNameStrg) (FT_HANDLE hFt);
  ''  typedef LPCSTR      (__stdcall *DLL_GetFtLibErrorString) (DWORD dwErrorCode, DWORD dwTyp);

  ''  typedef DWORD       (__stdcall *DLL_GetFtDeviceSetting) (FT_HANDLE hFt, FT_SETTING *pSet);
  ''  typedef DWORD       (__stdcall *DLL_SetFtDeviceSetting) (FT_HANDLE hFt, FT_SETTING *pSet);
  ''  typedef DWORD       (__stdcall *DLL_SetFtDistanceSensorMode) (FT_HANDLE hFt, DWORD dwMode, DWORD dwTol1, DWORD dwTol2, 
  ''                                                                DWORD dwSchwell1, DWORD dwSchwell2, DWORD dwRepeat1, DWORD dwRepeat2);

  ''  typedef DWORD       (__stdcall *DLL_StartFtTransferArea) (FT_HANDLE hFt, NOTIFICATION_EVENTS* sNEvent );
  ''  typedef DWORD       (__stdcall *DLL_StartFtTransferAreaWithCommunication) (FT_HANDLE hFt, NOTIFICATION_EVENTS* sNEvent );
  ''  typedef DWORD       (__stdcall *DLL_StopFtTransferArea) (FT_HANDLE hFt);
  ''  typedef FT_TRANSFER_AREA* (__stdcall *DLL_GetFtTransferAreaAddress) (FT_HANDLE hFt);
  ''  typedef DWORD       (__stdcall *DLL_IsFtTransferActiv) (FT_HANDLE hFt);
  ''  typedef DWORD       (__stdcall *DLL_ResetFtTransfer)  (FT_HANDLE hFt);
    
  ''  typedef DWORD       (__stdcall *DLL_GetFtMemoryLayout) (FT_HANDLE hFt, BYTE * pbArray, DWORD dwSize);
  ''  typedef DWORD       (__stdcall *DLL_DownloadFtProgram) (FT_HANDLE hFt, DWORD dwMemBlock, BYTE* pbArray, DWORD dwSize, DWORD dwParameter, BYTE *pbName, DWORD dwNameLen);
  ''  typedef DWORD       (__stdcall *DLL_StartFtProgram) (FT_HANDLE hFt, DWORD dwMemBlock);
  ''  typedef DWORD       (__stdcall *DLL_StopFtProgram) (FT_HANDLE hFt);
  ''  typedef DWORD       (__stdcall *DLL_DeleteFtProgram) (FT_HANDLE hFt, DWORD dwMemBlock);
  ''  typedef DWORD       (__stdcall *DLL_SetFtProgramActiv) (FT_HANDLE hFt, DWORD dwMemBlock);
  ''  typedef DWORD       (__stdcall *DLL_GetFtProgramName) (FT_HANDLE hFt, DWORD dwMemBlock, DWORD dwSize, LPVOID pName);
  ''  typedef DWORD       (__stdcall *DLL_WriteFtMemoryData) (FT_HANDLE hFt, DWORD dwData, DWORD dwAddress);
  ''  typedef DWORD       (__stdcall *DLL_GetFtMemoryData) (FT_HANDLE hFt, BYTE * pbArray, DWORD dwSize, DWORD dwAddress);

  ''  typedef DWORD       (__stdcall *DLL_SendFtMessage) (FT_HANDLE hFt, BYTE bHwId, BYTE bSubId, DWORD dwMessage, DWORD dwWaitTime); 
  ''  typedef DWORD       (__stdcall *DLL_ClearFtMessageBuffer) (FT_HANDLE hFt);


 







''/********************************************************
'' *  LoadFtLibDll
'' *
'' *  This function loads the FtLib-Dll
'' *
'' *  Calling:    ---
'' *  Return:     DWORD 
'' *              FTLIB_ERR_DLL_NOT_LOADABLE      Error: DLL not loadable
'' *              FTLIB_ERR_SUCCESS               Success: no error
'' *          
'' ********************************************************/

declare sub ft_data_transfer cdecl (ByVal any_pointer as any ptr)

declare sub wait_on_ft()



FUNCTION LoadFtLibDll() as DWORD

 DIM   dwStatus AS DWORD
  
    dwStatus =   FTLIB_ERR_SUCCESS
    hFtLibDLL = DYLIBLOAD("FtLib.dll")
    IF (hFtLibDLL <> 0) THEN
    
        GetLibVersion =               DyLibSymbol(hFtLibDLL, "GetLibVersion")
        InitFtLib =                   DyLibSymbol(hFtLibDLL, "InitFtLib")
        CloseFtLib =                  DyLibSymbol(hFtLibDLL, "CloseFtLib")
        IsFtLibInit =                 DyLibSymbol(hFtLibDLL, "IsFtLibInit")
        InitFtUsbDeviceList =         DyLibSymbol(hFtLibDLL, "InitFtUsbDeviceList")
        GetNumFtUsbDevice =           DyLibSymbol(hFtLibDLL, "GetNumFtUsbDevice")
        GetFtUsbDeviceHandle =        DyLibSymbol(hFtLibDLL, "GetFtUsbDeviceHandle")
        GetFtUsbDeviceHandleSerialNr = DyLibSymbol(hFtLibDLL, "GetFtUsbDeviceHandleSerialNr")
        OpenFtUsbDevice =             DyLibSymbol(hFtLibDLL, "OpenFtUsbDevice")
        OpenFtCommDevice =            DyLibSymbol(hFtLibDLL, "OpenFtCommDevice")
        SetFtDeviceCommMode =         DyLibSymbol(hFtLibDLL, "SetFtDeviceCommMode") 
        CloseAllFtDevices =           DyLibSymbol(hFtLibDLL, "CloseAllFtDevices")
        CloseFtDevice =               DyLibSymbol(hFtLibDLL, "CloseFtDevice")
        GetFtDeviceTyp =              DyLibSymbol(hFtLibDLL, "GetFtDeviceTyp")
        GetFtSerialNrStrg =           DyLibSymbol(hFtLibDLL, "GetFtSerialNrStrg")
        GetFtSerialNr =               DyLibSymbol(hFtLibDLL, "GetFtSerialNr")
        GetFtFirmwareStrg =           DyLibSymbol(hFtLibDLL, "GetFtFirmwareStrg")
        GetFtFirmware =               DyLibSymbol(hFtLibDLL, "GetFtFirmware")
        GetFtManufacturerStrg =       DyLibSymbol(hFtLibDLL, "GetFtManufacturerStrg")
        GetFtShortNameStrg =          DyLibSymbol(hFtLibDLL, "GetFtShortNameStrg")
        GetFtLongNameStrg =           DyLibSymbol(hFtLibDLL, "GetFtLongNameStrg")
        GetFtLibErrorString =         DyLibSymbol(hFtLibDLL, "GetFtLibErrorString")
        GetFtDeviceSetting =          DyLibSymbol(hFtLibDLL, "GetFtDeviceSetting")
        SetFtDeviceSetting =          DyLibSymbol(hFtLibDLL, "SetFtDeviceSetting")
        SetFtDistanceSensorMode =     DyLibSymbol(hFtLibDLL, "SetFtDistanceSensorMode")

        StartFtTransferArea =         DyLibSymbol(hFtLibDLL, "StartFtTransferArea")
        StartFtTransferAreaWithCommunication = DyLibSymbol(hFtLibDLL, "StartFtTransferAreaWithCommunication")
        StopFtTransferArea =          DyLibSymbol(hFtLibDLL, "StopFtTransferArea")
        GetFtTransferAreaAddress =    DyLibSymbol(hFtLibDLL, "GetFtTransferAreaAddress")
        IsFtTransferActiv =           DyLibSymbol(hFtLibDLL, "IsFtTransferActiv")
        ResetFtTransfer =             DyLibSymbol(hFtLibDLL, "ResetFtTransfer")
    
        GetFtMemoryLayout =           DyLibSymbol(hFtLibDLL, "GetFtMemoryLayout")
        DownloadFtProgram =           DyLibSymbol(hFtLibDLL, "DownloadFtProgram")
        StartFtProgram =              DyLibSymbol(hFtLibDLL, "StartFtProgram")
        StopFtProgram =               DyLibSymbol(hFtLibDLL, "StopFtProgram")
        DeleteFtProgram =             DyLibSymbol(hFtLibDLL, "DeleteFtProgram")
        SetFtProgramActiv =           DyLibSymbol(hFtLibDLL, "SetFtProgramActiv")
        GetFtProgramName =            DyLibSymbol(hFtLibDLL, "GetFtProgramName")
        WriteFtMemoryData =           DyLibSymbol(hFtLibDLL, "WriteFtMemoryData")
        GetFtMemoryData =             DyLibSymbol(hFtLibDLL, "GetFtMemoryData")

        SendFtMessage =               DyLibSymbol(hFtLibDLL, "SendFtMessage")
        ClearFtMessageBuffer =        DyLibSymbol(hFtLibDLL, "ClearFtMessageBuffer")
    
    ELSE
    
        DyLibFree(hFtLibDLL)
        dwStatus = FTLIB_ERR_DLL_NOT_LOADABLE
    
    ENDIF
    RETURN dwStatus
 END FUNCTION



''/********************************************************
'' *  UnloadFtLibDll
'' *
'' *  This Function kills the Library
'' *
'' *  Aufruf: ---
'' *  Return: DWORD 
'' *          0       Fehler, GetLastError() verwenden fr Fehlercode
'' *          >0      kein Fehler
'' *          
'' ********************************************************/

FUNCTION UnloadFtLibDll()as DWORD
    DIM dwStatus AS DWORD
    dwStatus = 0
    DyLibFree(hFtLibDLL)
    hFtLibDLL = NULL
    RETURN dwStatus
END FUNCTION





FUNCTION ANALOG_X() as USHORT
 RETURN ftDCB->AX
END FUNCTION 

FUNCTION ANALOG_Y() as USHORT
 RETURN ftDCB->AY
END FUNCTION 

FUNCTION ANALOG_X_Ohm() as USHORT
 RETURN ftDCB->AX_R
END FUNCTION 
	
FUNCTION ANALOG_Y_Ohm() as USHORT
 RETURN ftDCB->AY_R
END FUNCTION 


FUNCTION ANALOG_1() as USHORT
 RETURN ftDCB->A1
END FUNCTION 

FUNCTION ANALOG_2() as USHORT
 RETURN ftDCB->A2
END FUNCTION 

FUNCTION ANALOG_D1() as USHORT
 RETURN ftDCB->D1
END FUNCTION 

FUNCTION ANALOG_D2() as USHORT
 RETURN ftDCB->D2
END FUNCTION 

FUNCTION ANALOG_Z() as USHORT
 RETURN ftDCB->AZ
END FUNCTION 

FUNCTION ANALOG_V() as USHORT
 RETURN ftDCB->AV
END FUNCTION 

''SUB MOTOR (BYVAL Nummer as UBYTE ,BYVAL Speed AS UBYTE)

FUNCTION Eingang(Nummer as UBYTE) as UBYTE
  DIM INREG as UINTEGER
  DIM MASK AS UINTEGER
  DIM RESULT as UBYTE
  IF (Nummer>32 or Nummer=0) THEN
    PRINT "Falsche EingangsNummer";NUMMER
  ELSE
    INREG=ftDCB->E_SUB3 
    INREG=(INREG SHL 8)+ ftDCB->E_SUB2
    INREG=(INREG Shl 8)+ ftDCB->E_SUB1
    INREG=(INREG Shl 8)+ ftDCB->E_MAIN
    MASK= 1 SHL (NUMMER -1)
    IF((INREG and MASK) >0) THEN
      RESULT= 1
    ELSE
      RESULT=0
    END IF
  ENDIF
  RETURN RESULT
END Function



SUB Ausgang(BYVAL Nummer as UBYTE,BYVAL PWM as UByte, BYVAL Value as UBYTE)
  DIM OUTREG as UINTEGER
  DIM MASK AS UINTEGER
  DIM RESULT as UBYTE
  Dim prt_pwm As UBYTE Ptr
  IF (Nummer>32 or Nummer=0) THEN
    PRINT "Falsche AusgangsNummer";NUMMER
  ELSE
    MutexLock outsync 
    OUTREG=ftDCB->M_SUB3 
    OUTREG=(OUTREG Shl 8)+ ftDCB->M_SUB2
    OUTREG=(OUTREG Shl 8)+ ftDCB->M_SUB1
    OUTREG=(OUTREG Shl 8)+ ftDCB->M_MAIN
    MASK= 1 SHL (NUMMER -1)
    If Value >0 Then
    	 OUTREG=OUTREG Or MASK
    Else
    	 OUTREG=OUTREG And Not ( MASK)    	 
    EndIf
    ftDCB->M_MAIN=OUTREG And &h000000FF 
    ftDCB->M_SUB1=(OUTREG And &h0000FF00) Shr 8 
    ftDCB->M_SUB2=(OUTREG And &h00FF0000) Shr 16
    ftDCB->M_SUB2=(OUTREG And &hFF000000) Shr 24
    prt_pwm = @ftDCB->MPWM_Main(0)
    prt_pwm[Nummer-1]=PWM
    MutexUnlock outsync
  EndIf
 ' Print "Lampe";Nummer-1;" PWM=";PWM;" Befehl=";Value
END Sub

Sub Motor(BYVAL Nummer as UBYTE,BYVAL PWM as UByte, BYVAL Richtung As UBYTE)
  DIM OUTREG as UINTEGER
  DIM MASK AS UINTEGER
  Dim VALREG As UINTEGER
  DIM RESULT as UBYTE
  Dim prt_pwm As UBYTE Ptr
  IF (Nummer>16 or Nummer=0) THEN
    PRINT "Falsche Motor Nummer"
  Else
    MutexLock outsync
  
  	 VALREG= RICHTUNG And &h3
    OUTREG=ftDCB->M_SUB3 
    OUTREG=(OUTREG Shl 8)+ ftDCB->M_SUB2
    OUTREG=(OUTREG Shl 8)+ ftDCB->M_SUB1
    OUTREG=(OUTREG Shl 8)+ ftDCB->M_MAIN
    MASK= 3 SHL ((Nummer -1)*2)
    VALREG= VALREG Shl  ((Nummer -1)*2)   
    OUTREG=OUTREG And Not ( MASK)    	 
    OUTREG=OUTREG or VALREG  
    ftDCB->M_MAIN=OUTREG And &h000000FF 
    ftDCB->M_SUB1=(OUTREG And &h0000FF00) Shr 8 
    ftDCB->M_SUB2=(OUTREG And &h00FF0000) Shr 16
    ftDCB->M_SUB2=(OUTREG And &hFF000000) Shr 24
    prt_pwm = @ftDCB->MPWM_Main(0)
    prt_pwm[(Nummer-1)*2]=PWM
    prt_pwm[(Nummer-1)*2+1]=PWM
   MutexUnlock outsync
  EndIf
'  Print "Motor";Nummer-1;" PWM=";PWM;" Befehl=";Richtung
END Sub

Sub PrintTimer()
	Print ftDCB->Timer1ms;" "
	Print ftDCB->Timer10ms;" "
	Print ftDCB->Timer100ms;" "
	Print ftDCB->Timer1s;" "
End Sub


sub Wait_Impuls_Auf(Nummer as UBYTE)
 while ( Eingang(Nummer)=1)
     wait_on_ft()
 wend
 while (Eingang(Nummer)=0)
     wait_on_ft()
 wend
end sub

sub Wait_Impuls_Ab(Nummer as UBYTE)
 while ( Eingang(Nummer)=0)
     wait_on_ft()
 wend
 while (Eingang(Nummer)=1)
     wait_on_ft()
 wend
end sub    

sub fischer_end() 
  dwStatus = StopFtTransferArea(hUsb)  ''  
  dwStatus = CloseFtLib()
  UnloadFtLibDll()
  MutexDestroy outsync
  If ft_transfer_ready Then CondDestroy (ft_transfer_ready)


  print "Interface is closed"
end Sub  

Sub exit_thread(i as integer)
 dim Erg as integer 
 do
  do
   sleep 50
   Loop until INKEY$ = "q"
   Erg = MessageBox (0,"Do you want to leave?",_ 
                    "Frage", MB_ICONQUESTION or MB_YESNO ) 

   If Erg = IDYES Then 
     MessageBox (0,"Proramm wird terminiert ",_ 
                "schade..",MB_OK ) 
     fischer_end()
     END
   Else 
     MessageBox (0,"Also doch nicht !",_ 
                "Hmpff..",MB_ICONWARNING Or MB_OK ) 
   End If 
 loop
End Sub





SUB fischer_start()
  DIM dwAnzDev as DWORD 
  Dim result   as DWORD
  print "Freebasic & Fischertechnik       Werner Hobelbrecht"
  end_thread=ThreadCreate(@exit_thread,0)
  outsync = MutexCreate
  print "Starting the ft_interface"
  result=LoadFtLibDll()
  print "Lib_Version           : ";GetLibVersion()
  dwStatus = InitFtLib()
  print "Init                  : "; dwStatus
  dwStatus = InitFtUsbDeviceList()
  dwAnzDev = GetNumFtUsbDevice()
  print "Number of USB Devices : ";dwAnzDev
  hUsb = GetFtUsbDeviceHandle(0)
  print "DeviceTyp             : ";
  Select Case As Const GetFtDeviceTyp(hUsb) 
     Case NO_FT_DEVICE
        Print "NO_FT_DEVICE 0"
     Case FT_AUTO_TYPE 
        Print "FT_AUTO_TYPE 1"
     Case FT_INTELLIGENT_IF
        Print "FT_INTELLIGENT_IF 10"
     Case FT_INTELLIGENT_IF_SLAVE
        Print "FT_INTELLIGENT_IF_SLAVE 20"
     Case FT_ROBO_IF_IIM
        Print "FT_ROBO_IF_IIM 50"
     Case FT_ROBO_IF_USB
        Print "FT_ROBO_IF_USB 60"  
     Case FT_ROBO_IF_COM
        Print "FT_ROBO_IF_COM 70" 
     Case FT_ROBO_IF_OVER_RF 
        Print "FT_ROBO_IF_OVER_RF 80"
     Case FT_ROBO_IO_EXTENSION 
        Print "FT_ROBO_IO_EXTENSION 90"  
     Case FT_ROBO_RF_DATA_LINK
        Print "FT_ROBO_RF_DATA_LINK 110"       
     Case Else
        Print "number is outside of range"
  End SELECT
  

  print "SerialNr              : "; *GetFtSerialNrStrg(hUsb)
  print "Firmware              : "; *GetFtFirmwareStrg(hUsb)
  print "Manufacturer          : "; *GetFtManufacturerStrg(hUsb)
  print "Name                  : "; *GetFtShortNameStrg(hUsb)
  print "OpenUSB               : ";  
  dwStatus=OpenFtUsbDevice(hUsb)
  if dwStatus= 0 then
    print "ok"
  else
    print "Error"
  endif  
 
 
  
  '' create conditionals
  ft_transfer_ready = CondCreate()
  if ft_transfer_ready =0 then
    print"Error to create Condcreate"
  Endif
  
  ft_call_backs.NotificationCallback=@ft_data_transfer
  ft_call_backs.Context=0
  ft_call_backs.hEvent=0
  ft_call_backs.WindowsHandle=0
  ft_call_backs.Message=0
  ft_call_backs.CallbackMessage=0
  
  dwStatus = StartFtTransferArea(hUsb,@ft_call_backs)

  if dwStatus = FTLIB_ERR_SUCCESS THEN
    ftDCB = GetFtTransferAreaAddress(hUsb)
    print"Supply-Voltage        : ";CDbl(Analog_V())/100;" Volt"
  
    print "The Interface is working"
    Print "Press q to quit
  else
    dwStatus = CloseFtLib()
    UnloadFtLibDll()
    Print "Error during starting the Interface"
    SLEEP 5000
    END
  endif    
End Sub    
    
sub wait_on_ft
  sleep 2  
  CondWait ft_transfer_ready
end Sub

sub ft_data_transfer cdecl (byval any_pointer as any ptr)  
 CondBroadcast ft_transfer_ready 
end sub      